require_dependency 'application_controller'

module Logistics
  module Core
    class ClientsController < ApplicationController

      include ControllerCommon
      include LookupList

      def index
        clients = Client.includes(:client_category, :country).order(:name)
        data = ApplicationRecord.as_json(clients)
        response = Mks::Common::MethodResponse.new(true, nil, data, nil)
        render json: response
      end


      private

      def model_params
        params.require(:client).permit(:name, :postal_code, :city, :country_id, :telephone, :fax, :email, :license, :tin,
                                       :client_category_id, :code)
      end

    end
  end
end
