module Logistics
  module Core
    class ContainerStorageRatesController < ApplicationController
      def index
        rate_period_id = params[:rate_period_id]
        @container_storage_rates = ContainerStorageRate.where('warehouse_rate_period_id' => rate_period_id)
        container_storage_rate_array =[]
        @container_storage_rates.each { |csr|
          container_storage_rate_array.push({:id => csr.id, :container_size_name=> csr.container_size.name,
                                              :transaction_name => csr.transaction_type.name,
                                              :content_type_name => csr.content_type.name,
                                              :container_type_name => csr.container_type.name,
                                              :rate => csr.rate, :effective_date => csr.effective_date
                                             })
        }
        @response = Mks::Common::MethodResponse.new(true, nil, container_storage_rate_array, nil, nil)
        render json: @response
      end

      def create
        ContainerStorageRate.generate_storage_rate params[:rate_period_id], params[:effective_date]
        response = Mks::Common::MethodResponse.new(true, 'Container storage rate matrix generated successfully !', nil, nil, nil)
        render json: response
      end

      def update
        container_storage_rates = params[:container_storage_rates]
        container_storage_rates.each { |csr|
          old_container_storage_rate = ContainerStorageRate.find(csr['id'])
          old_container_storage_rate.rate = csr['rate']
          old_container_storage_rate.effective_date = csr['effective_date']
          old_container_storage_rate.save
        }
        @response = Mks::Common::MethodResponse.new(true, 'Container storage rate(s) updated successfully !', nil, nil, nil)
        render json: @response
      end

      private

      # Never trust parameters from the scary internet, only allow the white list through.
      def container_storage_rate_params
        params.require(:container_storage_rate).permit(:warehouse_rate_period_id, :rate, :container_size_id, :transaction_type_id, :effective_date, :content_type_id, :container_type_id)
      end
    end
  end
end
