module Logistics
  module Core
    class EslTransportTariffsController < ApplicationController
      before_action :set_esl_transport_tariff, only: [:update]

      def index
        esl_transport_tariffs = EslTransportTariff.includes(:route)
        data = ApplicationRecord.as_json(esl_transport_tariffs)
        response = Mks::Common::MethodResponse.new(true, nil, data, nil, nil)
        render json: response
      end

      def create
        @esl_transport_tariff = EslTransportTariff.new(esl_transport_tariff_params)
        if @esl_transport_tariff.save
          response = Mks::Common::MethodResponse.new(true, 'ESL transport tariff saved successfully!', @esl_transport_tariff, nil, nil)
        else
          errors = Mks::Common::Util.error_messages @esl_transport_tariff, 'ESL transport tariff'
          response = Mks::Common::MethodResponse.new(false, nil, nil, errors, nil)
        end
        render json: response
      end

      def update
        if @esl_transport_tariff.update(esl_transport_tariff_params)
          response = Mks::Common::MethodResponse.new(true, "ESL transport tariff updated successfully!", @esl_transport_tariff, nil, nil)
        else
          errors = Mks::Common::Util.error_messages @esl_transport_tariff, "ESL transport tariff"
          response = Mks::Common::MethodResponse.new(false, nil, nil, errors, nil)
        end
        render json: response
      end

      private

      def set_esl_transport_tariff
        @esl_transport_tariff = EslTransportTariff.find(params[:id])
      end

      def esl_transport_tariff_params
        params.require(:esl_transport_tariff).permit(:route_id, :storage_point)
      end
    end
  end
end
