module Logistics
  module Core
    class BillOfLadingRate < ApplicationRecord
      belongs_to :chargeable_service_unit_of_charge
      belongs_to :transaction_type

      def self.get_chargeable_services(service_delivery_unit_id)
        unit_of_charge_id = UnitOfCharge.select(:id).where('code' => 'BL')
        csuocs = ChargeableServiceUnitOfCharge.where('service_delivery_unit_id' => service_delivery_unit_id, 'unit_of_charge_id' => unit_of_charge_id )
        return csuocs
      end

      def self.generate_rate_for_bill_of_loading_services(effective_date)
        transaction_types = TransactionType.all
        service_delivery_units = ServiceDeliveryUnit.all
        service_delivery_units.each { |sdu|
          transaction_types.each { |transaction_type|
            chargeable_services = get_chargeable_services(sdu.id)
            chargeable_services.each { |chargeable_service|
              bill_of_loading_rate = BillOfLadingRate.where('transaction_type_id' =>transaction_type.id,
                                                            'chargeable_service_unit_of_charge_id' => chargeable_service.id)
              if bill_of_loading_rate.count == 0
                BillOfLadingRate.create('transaction_type_id' => transaction_type.id,'chargeable_service_unit_of_charge_id' =>
                    chargeable_service.id, 'low' => 0, 'medium' => 0,'high' => 0,
                                        'margin' => 0,'effective_date' => effective_date)
              end
            }
          }
        }
      end
    end
  end
end