module Logistics
  module Core
    class ContainerStorageRate < ApplicationRecord
      belongs_to :container_size
      belongs_to :transaction_type
      belongs_to :warehouse_rate_period
      belongs_to :container_type
      belongs_to :content_type

      def self.generate_storage_rate(rate_period_id, effective_date)
        transaction_types = TransactionType.all
        container_sizes = ContainerSize.all
        content_types = ContentType.all
        container_types = ContainerType.all
        transaction_types.each { |t|
          container_sizes.each { |c|
            content_types.each { |ct|
              container_types.each { |container_type|
                rate = ContainerStorageRate.where('transaction_type_id' => t.id, 'container_size_id' => c.id,
                                                  'content_type_id' => ct.id, 'container_type_id' => container_type.id,
                                                  'warehouse_rate_period_id' => rate_period_id)
                if rate.count == 0
                  ContainerStorageRate.create('transaction_type_id' => t.id, 'container_size_id' => c.id, 'rate' => 0,
                                              'content_type_id' => ct.id, 'container_type_id' => container_type.id,
                                              'warehouse_rate_period_id' => rate_period_id, 'effective_date' => effective_date)
                end
              }
            }
          }
        }
      end
    end
  end
end