module Logistics
	module Core
	  class ContractBreakBulkUnitRate < ApplicationRecord
      belongs_to :break_bulk_unit
      belongs_to :contract
      belongs_to :transaction_type
      belongs_to :chargeable_service_unit_of_charge

      def self.get_service_delivery_units
        transport_id = ServiceDeliveryUnitType.select(:id).where('lower(name) = ?', 'Transport'.downcase)
        return ServiceDeliveryUnit.where.not('service_delivery_unit_type_id' => transport_id)
      end

      def self.get_chargeable_services(service_delivery_unit_id)
        unit_of_charge_id = UnitOfCharge.select(:id).where('code' => 'UNIT')
        acsuocs = ChargeableServiceUnitOfCharge.where('service_delivery_unit_id' => service_delivery_unit_id, 'unit_of_charge_id' => unit_of_charge_id )
        return acsuocs
      end

      def self.generate_rate_for_break_bulk_unit_service(client_contract_id)
        service_delivery_units = get_service_delivery_units
        transaction_types = TransactionType.all
        break_bulk_units = BreakBulkUnit.all
        service_delivery_units.each{ |sdu|
          transaction_types.each { |transaction_type|
            break_bulk_units.each {|bbu|
              chargeable_services = get_chargeable_services(sdu.id)
              chargeable_services.each { |cs|
                service_rate = ContractBreakBulkUnitRate.where('chargeable_service_unit_of_charge_id' => cs.id, 'transaction_type_id' => transaction_type.id,
                                                               'break_bulk_unit_id' => bbu.id, 'contract_id' => client_contract_id)
                if service_rate.count == 0
                  ContractBreakBulkUnitRate.create('chargeable_service_unit_of_charge_id' => cs.id, 'transaction_type_id' => transaction_type.id,
                                                   'break_bulk_unit_id' => bbu.id, 'rate' => 0, 'contract_id' => client_contract_id,
                                                   'margin' => 0)
                end
              }
            }
          }
        }
      end
		end
	end
end