module Logistics
  module Core
    class DocumentType < ApplicationRecord
      include Lookupable

      validates :code, :name, presence: true, allow_blank: false
      validates :code, :name, uniqueness: true

      belongs_to :document_type_category
      belongs_to :document_type_origin

      delegate(:name, to: :document_type_category, prefix: true)
      delegate(:name, to: :document_type_origin, prefix: true)
    end
  end
end