module Logistics
  module Core
    class FreightTonDemurrageRate < ApplicationRecord
      belongs_to :demurrage_rate_period
      belongs_to :transaction_type

      def self.generate_demurage_rate(rate_period_id, effective_date)
        transaction_types = get_transaction_types
        transaction_types.each { |tt|
          tdr = FreightTonDemurrageRate.where('transaction_type_id' => tt.id, 'demurage_rate_period_id' => rate_period_id)
          if tdr.count == 0
            FreightTonDemurrageRate.create('transaction_type_id' => tt.id, 'demurage_rate_period_id' => rate_period_id,
                                           'rate' => 0, 'effective_date' => effective_date)
          end
        }
      end
    end
  end
end