module Logistics
  module Core
    class FreightTonStorageRate < ApplicationRecord
      belongs_to :content_type
      belongs_to :transaction_type
      belongs_to :warehouse_rate_period

      def self.generate_storage_rate(rate_period_id, effective_date)
        transaction_types = TransactionType.all
        content_types = ContentType.all
        transaction_types.each { |tt|
          content_types.each { |ct|
            fsr = FreightTonStorageRate.where('transaction_type_id' => tt.id, 'warehouse_rate_period_id' => rate_period_id,
                                              'content_type_id' => ct.id)
            if fsr.count == 0
              FreightTonStorageRate.create('transaction_type_id' => tt.id, 'warehouse_rate_period_id' => rate_period_id,
                                           'content_type_id' => ct.id,'rate' => 0, 'effective_date' => effective_date)
            end

          }
        }
      end
    end
  end
end