Logistics::Core::Engine.routes.draw do
  resources :currencies, except: [:new, :edit, :show, :destroy] do
    member do
      get 'rates', :controller => :currency_rates, :action => :rates
    end
  end
  resources :client_categories
  get 'increment_rates/get_all'
  get 'addendums/get_all'
  resources :service_increments do
    member do
      get 'increments'
      get 'unassigned_increments'
    end
    resources :increment_rates
    resources :addendums
  end
  put '/update_service/:id', :to => 'service_delivery_unit_services#update'
  put '/remove_service/:id', :to => 'service_delivery_unit_services#delete'
  post '/offer_requests/set_security_status', :controller => 'offer_requests', :action => 'set_security_status'
  get '/offer_requests/get_request_by_security_status', :controller => 'offer_requests', :action => 'get_request_by_security_status'
  put '/offer_requests/change_sent_status', :controller => 'offer_requests', :action => 'change_sent_status'
  get '/offer_requests/requests_with_additional_services', :controller => 'offer_requests', :action => 'get_requests_with_additional_service'
  get '/carriers/:carrier_id/engaged_agents', :controller => 'carriers', :action => 'engaged_agents'
  get '/carriers/:carrier_id/unengaged_agents', :controller => 'carriers', :action => 'unengaged_agents'

  post 'carrier_agents/', :controller => 'carrier_agents', :action => 'create'
  get 'carrier_agents', :controller => 'carrier_agents', :action => 'index'

  put '/offer_requests/update_demurage_detail', :controller => 'offer_requests', :action => 'update_demurage_detail'
  get '/warehouses/get_requests_without_storage_data', :controller => 'warehouses', :action => 'get_requests_without_storage_data'
  put '/offer_requests/update_storage_detail', :controller => 'offer_requests', :action => 'update_storage_detail'
  get 'warehouses/get_requests_with_storage_data', :controller => 'warehouses', :action => 'get_requests_with_storage_data'
  get 'service_delivery_units/get_sdus_with_specific_services',:controller => 'service_delivery_units', :action => 'get_sdus_with_specific_services'

  post '/offer_request/status', :controller =>'offer_requests', :action => 'change_status'
  get '/offer_request/get_request_by_status', :controller => 'offer_requests', :action => 'get_request_by_status'
  get '/reference_numbers/:reference_type/get_next_reference_number', :controller => 'reference_numbers', :action => 'get_next_reference_number'
  get 'break_bulk_storage_rates', :controller => 'break_bulk_storage_rates', :action => 'index'
  post 'break_bulk_storage_rates', :controller => 'break_bulk_storage_rates', :action => 'create'
  put 'break_bulk_storage_rates/update', :controller => 'break_bulk_storage_rates', :action => 'update'

  get 'container_storage_rates', :controller => 'container_storage_rates', :action => 'index'
  post 'container_storage_rates', :controller => 'container_storage_rates', :action => 'create'
  put 'container_storage_rates/update', :controller => 'container_storage_rates', :action => 'update'

  get 'freight_ton_storage_rates', :controller => 'freight_ton_storage_rates', :action => 'index'
  post 'freight_ton_storage_rates', :controller => 'freight_ton_storage_rates', :action => 'create'
  put 'freight_ton_storage_rates/update', :controller => 'freight_ton_storage_rates', :action => 'update'

  get 'demurage_rate_periods', :controller => 'demurage_rate_periods', :action => 'index'
  post 'demurage_rate_periods', :controller => 'demurage_rate_periods', :action => 'create'
  put 'demurage_rate_periods/:id', :controller => 'demurage_rate_periods', :action => 'update'

  get 'container_demurage_rates', :controller => 'container_demurage_rates', :action => 'index'
  post 'container_demurage_rates', :controller => 'container_demurage_rates', :action =>'create'
  put 'container_demurage_rates/update', :controller => 'container_demurage_rates', :action => 'update'

  get 'special_increment_container_rates', :controller => 'special_increment_container_rates', :action => 'index'
  post 'special_increment_container_rates', :controller => 'special_increment_container_rates', :action => 'create'
  put 'special_increment_container_rates/:id', :controller => 'special_increment_container_rates', :action => 'update'

  get 'special_increment_content_rates', :controller => 'special_increment_content_rates', :action => 'index'
  post 'special_increment_content_rates', :controller => 'special_increment_content_rates', :action => 'create'
  put 'special_increment_content_rates/:id', :controller => 'special_increment_content_rates', :action => 'update'

  get 'twenty_feet_equivalence_ratios', :controller => 'twenty_feet_equivalence_ratios', :action => 'index'
  post 'twenty_feet_equivalence_ratios', :controller => 'twenty_feet_equivalence_ratios', :action => 'create'
  put 'twenty_feet_equivalence_ratios/:id', :controller => 'twenty_feet_equivalence_ratios', :action => 'update'

  get '/contract_truck_rates', :controller => 'contract_truck_rates', :action => 'index'
  post '/contract_truck_rates', :controller => 'contract_truck_rates', :action => 'create'
  put '/contract_truck_rates/update', :controller => 'contract_truck_rates', :action => 'update'

  get 'contract_convoy_rates', :controller => 'contract_convoy_rates', :action => 'index'
  post 'contract_convoy_rates', :controller => 'contract_convoy_rates', :action => 'create'
  put 'contract_convoy_rates/update', :controller => 'contract_convoy_rates', :action => 'update'

  get 'contract_freight_ton_rates', :controller => 'contract_freight_ton_rates', :action => 'index'
  post 'contract_freight_ton_rates', :controller => 'contract_freight_ton_rates', :action => 'create'
  put 'contract_freight_ton_rates/update', :controller => 'contract_freight_ton_rates', :action => 'update'

  get 'contract_kilogram_rates', :controller => 'contract_kilogram_rates', :action => 'index'
  post 'contract_kilogram_rates', :controller => 'contract_kilogram_rates', :action => 'create'
  put 'contract_kilogram_rates/:id', :controller => 'contract_kilogram_rates', :action => 'update'

  get 'contract_item_rates', :controller => 'contract_item_rates', :action => 'index'
  post 'contract_item_rates', :controller => 'contract_item_rates', :action => 'create'
  put 'contract_item_rates/update', :controller => 'contract_item_rates', :action => 'update'

  get 'contract_airway_bill_rates', :controller => 'contract_airway_bill_rates', :action => 'index'
  post 'contract_airway_bill_rates', :controller => 'contract_airway_bill_rates', :action => 'create'
  put 'contract_airway_bill_rates/update', :controller => 'contract_airway_bill_rates', :action => 'update'

  get 'contract_twenty_feet_equivalence_unit_rates', :controller => 'contract_twenty_feet_equivalence_unit_rates', :action => 'index'
  post 'contract_twenty_feet_equivalence_unit_rates', :controller => 'contract_twenty_feet_equivalence_unit_rates', :action => 'create'
  put 'contract_twenty_feet_equivalence_unit_rates/update', :controller => 'contract_twenty_feet_equivalence_unit_rates', :action => 'update'

  get 'contract_bill_of_loading_rates', :controller => 'contract_bill_of_loading_rates', :action => 'index'
  post 'contract_bill_of_loading_rates', :controller => 'contract_bill_of_loading_rates', :action => 'create'
  put 'contract_bill_of_loading_rates/update', :controller => 'contract_bill_of_loading_rates', :action => 'update'

  get 'contract_break_bulk_unit_rates', :controller => 'contract_break_bulk_unit_rates', :action => 'index'
  post 'contract_break_bulk_unit_rates', :controller => 'contract_break_bulk_unit_rates', :action => 'create'
  put 'contract_break_bulk_unit_rates/update', :controller => 'contract_break_bulk_unit_rates', :action => 'update'

  get 'get_contract_per_client', :controller => 'client_contracts', :action => 'get_contract_per_client'

  get 'contract_container_rates', :controller => 'contract_container_rates', :action => 'index'
  post 'contract_container_rates', :controller => 'contract_container_rates', :action => 'create'
  put 'contract_container_rates/update', :controller => 'contract_container_rates', :action => 'update'

  get 'air_cargo_limits', :controller => 'air_cargo_limits', :action => 'index'
  post 'air_cargo_limits', :controller => 'air_cargo_limits', :action => 'create'
  put 'air_cargo_limits/update', :controller => 'air_cargo_limits', :action => 'update'
  resources :chargeable_service_unit_of_charges do
    member do
      get 'increments'
      get 'unassigned_increments'
    end
  end

  post 'chargeable_service_unit_of_charges/update_changes', :controller => 'chargeable_service_unit_of_charges',
       :action => 'update_changes'

  get 'convoy_rates/index', :controller => 'convoy_rates', :action => 'index'
  post 'convoy_rates/create', :controller => 'convoy_rates', :action => 'create'
  put 'convoy_rates/update', :controller => 'convoy_rates', :action => 'update'

  get 'item_rates/index', :controller => 'item_rates', :action => 'index'
  post 'item_rates/create', :controller => 'item_rates', :action => 'create'
  put 'item_rates/update', :controller => 'item_rates', :action => 'update'

  get 'twenty_feet_equivalent_unit_rates/index', :controller => 'twenty_feet_equivalent_unit_rates', :action => 'index'
  post 'twenty_feet_equivalent_unit_rates/create', :controller => 'twenty_feet_equivalent_unit_rates', :action => 'create'
  put 'twenty_feet_equivalent_unit_rates/update', :controller => 'twenty_feet_equivalent_unit_rates', :action => 'update'

  resources :service_delivery_units do
    member do
      get 'chargeable_services'
      get 'unassigned_services'
    end
  end

  get '/currencies/:id/rates', to: 'currency_rates#rates'
  post '/currencies/:currency_id/rates', to: 'currency_rates#create'

  get '/get_client_contracts', :to => 'contracts#get_contract_by_client'
  get '/get_service_delivery_unit_by_cs_code', to: 'chargeable_service_unit_of_charges#get_sdus_by_cs_code'
  get '/get_cs_by_sdu_and_code', to: 'chargeable_service_unit_of_charges#get_cs_by_sdu_and_code'
  get '/get_cs_by_sdu', controller: :chargeable_service_unit_of_charges, action: :get_cs_by_sdu
  resources :contracts, only: [:index, :create, :update]
  resources :cargo_types, only: [:index, :create, :update]
  resources :content_types, only: [:index]
  resources :chargeable_service_types, except: [:new, :edit, :show, :destroy]
  resources :chargeable_services, except:[:new, :edit, :show, :destroy]
  resources :currency_rates, only: [:update]
  resources :transport_service_types, except: [:new, :edit, :show, :destroy]
  resources :chargeable_service_increments, except: [:new, :edit, :show, :destroy]
  resources :service_delivery_unit_services, except: [:new, :edit, :show, :destroy]
  resources :truck_rates, except: [:new, :edit, :show, :destroy]
  resources :kilogram_minimum_rates, only: [:index, :create, :update]
  resources :contract_kilogram_minimum_rates, only: [:index, :create, :update]
  resources :kilogram_rates, except: [:new, :edit, :show, :destroy]
  resources :service_rates, except: [:new, :edit, :show, :destroy]
  resources :break_bulk_unit_rates, except: [:new, :edit, :show, :destroy]
  resources :break_bulk_rates, except: [:new, :edit, :show, :destroy]
  resources :air_weigh_bills, except: [:new, :edit, :show, :destroy]
  resources :bill_of_loading_rates, except: [:new, :edit, :show, :destroy]
  resources :warehouse_rate_periods, except: [:new, :edit, :show, :destroy]
  resources :warehouses, except: [:new, :edit, :show, :destroy]
  resources :carrier_types, except: [:new, :edit, :show, :destroy]
  resources :carriers, except: [:new, :edit, :show, :destroy]
  resources :agents, except: [:new, :edit, :show, :destroy]
  resources :container_types, except: [:new, :edit, :show, :destroy]
  resources :container_sizes, except: [:new, :edit, :show, :destroy]
  resources :break_bulk_units, except: [:new, :edit]
  resources :currency_rates, only: [:create, :update]
  resources :countries, except: [:new, :edit, :show, :destroy]
  resources :clients, except: [:new, :edit, :show, :destroy]
  get 'clients/lookup', :to => 'clients#lookup'
  resources :customs_office_units, except: [:new, :edit, :show, :destroy]
  resources :operation_types, except: [:new, :edit, :show, :destroy]
  resources :service_delivery_unit_types, except: [:new, :edit, :show, :destroy]
  resources :transaction_types, except: [:new, :edit, :show, :destroy] do
    member do
      get 'declaration_types', :controller => :declaration_types, :action => :filter_by_transaction_type
    end
  end
  resources :unit_of_charges, except: [:new, :edit, :show, :destroy]
  resources :chargeable_services, except: [:new, :edit, :show, :destroy]
  resources :customs_offices, except: [:new, :edit, :show, :destroy]
  resources :operations, except: [:new, :edit, :show, :destroy] do
    member do
      get 'operation_documents', :controller => :operation_documents, :action => :index
    end
  end
  get 'operations/fresh', controller: :operations, action: :fresh
  get 'operations/for_client/:id', controller: :operations, action: :filter_fresh_by_client
  get 'operations/assigned', controller: :operations, action: :assigned
  get 'operations/unassigned', controller: :operations, action: :unassigned
  post 'operations/assign', controller: :operations, action: :assign

  resources :operation_documents do
    member do
      get 'accept'
      get 'download', controller: :operation_documents, action: :download
    end
  end
  resources :communication_channels, except: [:new, :edit, :show, :destroy]
  resources :offer_requests, except: [:edit, :show, :destroy]
  resources :route_lookups
  get '/transport_rate_periods/get_current_rate_period', :controller => 'transport_rate_periods', :action => 'get_current_rate_period'
  resources :transport_rate_periods
  resources :weight_ranges
  resources :broad_gauge_bbs
  resources :break_bulk_units
  resources :broad_gauge_cnts
  resources :container_sizes
  resources :container_types
  resources :routes
  get 'transporters/lookup'
  resources :transporters
  resources :break_bulk_truck_assignments
  resources :truck_type_assignments
  resources :route_rates
  get 'route_rates/:route_type/get_route', :controller => 'route_rates', :action => 'get_route'
  get 'route_rates/:transporter_id/current_route_rate', :controller => 'route_rates', :action => 'get_current_route_rate'
  post 'route_rates/save_current_route_rate', :controller => 'route_rates', :action => 'save_current_route_rate'

  get '/car_carrier_rates/get_car_carrier_routes', :controller => 'car_carrier_rates', :action => 'get_car_carrier_routes'
  get '/car_carrier_rates/get_car_carrier_rates', :controller => 'car_carrier_rates', :action => 'get_car_carrier_rates'
  post '/car_carrier_rates/get_min_max_transporter_rates', :controller => 'car_carrier_rates', :action => 'get_min_max_transporter_rates'
  post '/car_carrier_rates/reload_min_max_transporter_rates', :controller => 'car_carrier_rates', :action => 'reload_min_max_transporter_rates'
  post '/car_carrier_rates/create_working_rate', :controller => 'car_carrier_rates', :action => 'create_working_rate'
  resources :car_carrier_rates

  get '/self_driving_rates/get_self_driving_rates', :controller => 'self_driving_rates', :action => 'get_self_driving_rates'
  get '/self_driving_rates/get_self_driving_routes', :controller => 'self_driving_rates', :action => 'get_self_driving_routes'
  post '/self_driving_rates/get_min_max_transporter_rates', :controller => 'self_driving_rates', :action => 'get_min_max_transporter_rates'
  post '/self_driving_rates/reload_min_max_transporter_rates', :controller => 'self_driving_rates', :action => 'reload_min_max_transporter_rates'
  post '/self_driving_rates/create_working_rate', :controller => 'self_driving_rates', :action => 'create_working_rate'
  resources :self_driving_rates

  post '/out_of_gauge_bb_rates/search_route', :controller => 'out_of_gauge_bb_rates', :action => 'search_route'
  resources :out_of_gauge_bb_rates

  post '/out_of_gauge_cnt_rates/search_route', :controller => 'out_of_gauge_cnt_rates', :action => 'search_route'
  resources :out_of_gauge_cnt_rates
  resources :truck_type_bb_weight_ranges
  resources :truck_type_cnt_weight_ranges
  resources :unit_types
  resources :units

  resources :declaration_types

  resources :esl_transport_tariffs do
    member do
      get 'rates', :controller => :esl_transport_tariff_rates, :action => :filter_by_tariff
    end
  end
  resources :esl_transport_tariff_rates
  resources :declarants
  resources :customs_transport_tariffs
  resources :delivery_terms
  resources :entry_points
  resources :payment_terms
  resources :transport_modes
  resources :acquisition_modes
  resources :container_arrangements

  resources :document_type_origins
  resources :document_type_categories

  resources :document_types do
    collection do
      get 'lookup'
    end
  end

  resources :common_documents

  get '/additional_documents/lookup_values/:entity', :controller => :additional_documents, :action => :get_lookup_values
  get '/additional_documents/:entity/:rec_id', :controller => :additional_documents, :action => :get_document_types
  post '/additional_documents/save', :controller => :additional_documents, :action => :bulk_save
  post '/additional_documents/update', :controller => :additional_documents, :action => :bulk_update
  delete '/additional_documents/delete/', :controller => :additional_documents, :action => :bulk_delete

  resources :agency_categories

  get '/agencies/:id/get_permit_documents', :controller => 'agencies', :action => 'get_permit_documents'
  get '/agencies/:id/get_document_type_with_no_agency', :controller => 'agencies', :action => 'get_document_type_with_no_agency'
  resources :agencies
  get '/permit_required_documents', :controller => :agencies, :action => :get_permit_documents

  resources :agency_permit_documents do
    member do
      get 'required_documents', :controller => :required_documents, :action => :index
    end
  end

  resources :required_documents
  resources :contract_services, only: [:index, :create, :destroy] do
    member do
      post 'associate_service', controller: :contract_services, action: :associate_service
    end
  end
  resources :transport_modalities
  resources :standard_remarks, only: [:index, :create, :update]
end
