class CreateLogisticsCoreChargeableServices < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_chargeable_services do |t|
      t.string :code, null: false, unique: true
      t.string :name, null: false, unique: true
      t.integer :order
      t.references :chargeable_service_type, index: { name: 'cs_on_cst_indx' }
      t.references :transport_service_type, index: {name: 'cs_on_tst_indx'}

      t.timestamps
    end

    add_foreign_key :logistics_core_chargeable_services, :logistics_core_lookups, :column => :chargeable_service_type_id
    add_foreign_key :logistics_core_chargeable_services, :logistics_core_lookups, :column => :transport_service_type_id
  end
end
