class CreateLogisticsCoreClients < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_clients do |t|
      t.string :name, null: false
      t.string :postal_code
      t.string :city
      t.references :country, index: true
      t.references :client_category, index: { name: 'clent_on_client_category_indx' }
      t.string :telephone
      t.string :fax
      t.string :email
      t.string :license
      t.string :tin

      t.timestamps
    end

    add_foreign_key :logistics_core_clients, :logistics_core_lookups, :column => :country_id
    add_foreign_key :logistics_core_clients, :logistics_core_lookups, :column => :client_category_id, name: 'fk_cl_on_cc'
  end
end
