class CreateLogisticsCoreOperations < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_operations do |t|
      t.string :operation_number, null: true, unique: true
      t.string :contract_number, null: true, unique: true
      t.references :client, index: { name: 'client_on_operation_indx' }
      t.boolean :is_new_customer, default: false
      t.string :status
      t.boolean :freight_forwarding, default: false
      t.boolean :customs_clearing, default: false
      t.boolean :transport, default: false
      t.references :operation_type, index: { name: 'operation_type_on_operation_indx' }
      t.references :transaction_type, index: { name: 'operation_on_transaction_type_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_operations, :logistics_core_clients, :column => :client_id
    add_foreign_key :logistics_core_operations, :logistics_core_lookups, :column => :operation_type_id
    add_foreign_key :logistics_core_operations, :logistics_core_lookups, :column => :transaction_type_id
  end
end
