class CreateLogisticsCoreChargeableServiceUnitOfCharges < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_chargeable_service_unit_of_charges do |t|
      t.references :service_delivery_unit, index: { name: 'csuoc_on_sdu_indx' }
      t.references :chargeable_service, index: { name: 'csuoc_on_cs_indx' }
      t.references :unit_of_charge, index: { name: 'csuoc_on_uoc_indx' }
      t.boolean :has_increment
      t.boolean :has_container_special_increment
      t.boolean :has_content_special_increment

      t.timestamps
    end

    add_foreign_key :logistics_core_chargeable_service_unit_of_charges, :logistics_core_service_delivery_units,
                    :column => :service_delivery_unit_id
    add_foreign_key :logistics_core_chargeable_service_unit_of_charges, :logistics_core_chargeable_services,
                    :column => :chargeable_service_id
    add_foreign_key :logistics_core_chargeable_service_unit_of_charges, :logistics_core_lookups,
                    :column => :unit_of_charge_id
  end
end
