class CreateLogisticsCoreAirCargoLimits < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_air_cargo_limits do |t|
      t.references :chargeable_service_unit_of_charge, index: { name: 'acl_on_csuoc_indx' }
      t.references :transaction_type, index: { name: 'acl_on_tt_indx' }
      t.float :lower_limit
      t.float :upper_limit
      t.float :over_charge_rate
      t.date :effective_date

      t.timestamps
    end

    add_foreign_key :logistics_core_air_cargo_limits, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_air_cargo_limits, :logistics_core_lookups, :column => :transaction_type_id
  end
end
