class CreateLogisticsCoreDemurrageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_demurrage_rates do |t|
      t.references :demurrage_rate_period, index: { name: 'dr_on_drp_indx' }
      t.references :unit_of_charge, index: { name: 'dr_on_uoc_indx' }
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_demurrage_rates, :logistics_core_demurrage_rate_periods,
                    :column => :demurrage_rate_period_id
    add_foreign_key :logistics_core_demurrage_rates, :logistics_core_lookups, :column => :unit_of_charge_id
  end
end
