class CreateLogisticsCoreBreakBulkDemurrageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_break_bulk_demurrage_rates do |t|
      t.references :break_bulk_unit, index: { name: 'bbdr_on_bbu_indx'}
      t.references :transaction_type, index: { name: 'bbdr_on_tt_indx' }
      t.references :demurrage_rate_period, index: { name: 'bbdr_on_drp_indx' }
      t.float :rate
      t.date :effective_date

      t.timestamps
    end

    add_foreign_key :logistics_core_break_bulk_demurrage_rates, :logistics_core_lookups, :column => :break_bulk_unit_id
    add_foreign_key :logistics_core_break_bulk_demurrage_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_break_bulk_demurrage_rates, :logistics_core_demurrage_rate_periods,
                    :column => :demurrage_rate_period_id
  end
end
