class CreateLogisticsCoreBreakBulkStorageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_break_bulk_storage_rates do |t|
      t.references :break_bulk_unit, index: { name: 'bbsr_on_bbu_indx' }
      t.references :transaction_type, index: { name: 'bbsr_on_tt_indx' }
      t.references :warehouse_rate_period, index: { name: 'bbsr_on_wrp_indx' }
      t.references :content_type, index: { name: 'bbsr_on_ct_indx' }
      t.float :rate
      t.date :effective_date

      t.timestamps
    end

    add_foreign_key :logistics_core_break_bulk_storage_rates, :logistics_core_lookups, :column => :break_bulk_unit_id
    add_foreign_key :logistics_core_break_bulk_storage_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_break_bulk_storage_rates, :logistics_core_warehouse_rate_periods,
                    :column => :warehouse_rate_period_id
    add_foreign_key :logistics_core_break_bulk_storage_rates, :logistics_core_lookups, :column => :content_type_id

  end
end
