class CreateLogisticsCoreBreakBulkRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_break_bulk_rates do |t|
      t.references :transaction_type, index: { name: 'bbr_on_tt_indx' }
      t.references :chargeable_service_unit_of_charge, index: { name: 'bbr_on_csuoc_indx' }
      t.float :low
      t.float :medium
      t.float :high
      t.date :effective_date
      t.float :margin

      t.timestamps
    end

    add_foreign_key :logistics_core_break_bulk_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_break_bulk_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
  end
end
