class CreateLogisticsCoreBreakBulkUnitRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_break_bulk_unit_rates do |t|
      t.references :chargeable_service_unit_of_charge, index: { name: 'bbur_on_csuoc_indx' }
      t.references :transaction_type, index: { name: 'bbur_on_tt_indx' }
      t.references :break_bulk_unit, index: { name: 'bbur_on_bbu_indx' }
      t.float :high
      t.float :medium
      t.float :low
      t.date :effective_date
      t.float :margin

      t.timestamps
    end
    add_foreign_key :logistics_core_break_bulk_unit_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_break_bulk_unit_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_break_bulk_unit_rates, :logistics_core_lookups, :column => :break_bulk_unit_id
  end
end
