class CreateLogisticsCoreSpecialIncrementContainerRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_special_increment_container_rates do |t|
      t.references :container_type, index: { name: 'sicr_on_cnt_indx' }
      t.float :rate
      t.date :effective_date

      t.timestamps
    end

    create_table :logistics_core_chargeable_service_container_type_rates, id: false do |t|
      t.belongs_to :special_increment_container_rate, index: false
      t.belongs_to :chargeable_service_unit_of_charge, index: false
    end

    add_index(:logistics_core_chargeable_service_container_type_rates, [ :special_increment_container_rate_id,
                                                              :chargeable_service_unit_of_charge_id],
              :name => 'idx_container_type_special_increment_1')

    add_foreign_key :logistics_core_chargeable_service_container_type_rates, :logistics_core_special_increment_container_rates,
                    :column => :special_increment_container_rate_id
    add_foreign_key :logistics_core_chargeable_service_container_type_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_special_increment_container_rates, :logistics_core_lookups,
                    :column => :container_type_id
  end
end
