class CreateLogisticsCoreServiceRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_service_rates do |t|
      t.references :container_size, index: { name: 'sr_on_cs_indx' }
      t.references :transaction_type, index: { name: 'sr_on_tt_indx' }
      t.references :chargeable_service_unit_of_charge, index: { name: 'sr_on_csuoc_indx' }
      t.float :low
      t.float :medium
      t.float :high
      t.date :effective_date
      t.float :margin

      t.timestamps
    end

    add_foreign_key :logistics_core_service_rates, :logistics_core_lookups, :column => :container_size_id
    add_foreign_key :logistics_core_service_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_service_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id

  end
end
