class CreateLogisticsCoreContainerDemurrageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_container_demurrage_rates do |t|
      t.references :container_size, index: { name: 'cdr_on_cs_indx' }
      t.references :transaction_type, index: { name: 'cdr_on_tt_indx' }
      t.references :demurrage_rate_period, index: { name: 'cdr_on_drp_indx' }
      t.references :container_type, index: { name: 'cdr_on_ct_indx' }
      t.references :content_type, index: { name: 'cdr_on_cnt_indx' }
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_container_demurrage_rates, :logistics_core_lookups, :column => :container_size_id
    add_foreign_key :logistics_core_container_demurrage_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_container_demurrage_rates, :logistics_core_lookups, :column => :container_type_id
    add_foreign_key :logistics_core_container_demurrage_rates, :logistics_core_lookups, :column => :content_type_id
    add_foreign_key :logistics_core_container_demurrage_rates, :logistics_core_demurrage_rate_periods,
                    :column => :demurrage_rate_period_id
  end
end
