class CreateLogisticsCoreRoutes < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_routes do |t|
      t.references :from, index: { name: 'route_on_rl_from_indx' }
      t.references :to, index: { name: 'route_on_rl_to_indx' }
      t.string :description
      t.references :node, index: { name: 'route_on_rl_node_indx' }
      t.string :zone
      t.float :radius
      t.string :route_type
      t.float :margin

      t.timestamps
    end

    add_foreign_key :logistics_core_routes, :logistics_core_lookups, :column => :from_id, name: 'fk_route_from'
    add_foreign_key :logistics_core_routes, :logistics_core_lookups, :column => :to_id, name: 'fk_route_to'
    add_foreign_key :logistics_core_routes, :logistics_core_lookups, :column => :node_id, name: 'fk_route_node'
  end
end
