class CreateLogisticsCoreRouteRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_route_rates do |t|
      t.float :rate
      t.references :route, index: { name: 'rr_on_route_indx' }
      t.references :transporter, index: { name: 'rr_on_transporter_indx' }
      t.references :weight_range, index: { name: 'rr_on_wr_indx' }
      t.references :rate_period, index: { name: 'rr_on_rp_indx' }
      t.string :rate_type
      t.references :container_size, index: { name: 'rr_on_cs_indx' }
      t.references :selected_transporter, index: { name: 'rr_on_st_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_route_rates, :logistics_core_routes, :column => :route_id
    add_foreign_key :logistics_core_route_rates, :logistics_core_transporters, :column => :transporter_id
    add_foreign_key :logistics_core_route_rates, :logistics_core_weight_ranges, :column => :weight_range_id
    add_foreign_key :logistics_core_route_rates, :logistics_core_transport_rate_periods, :column => :rate_period_id
    add_foreign_key :logistics_core_route_rates, :logistics_core_lookups, :column => :container_size_id
    add_foreign_key :logistics_core_route_rates, :logistics_core_transporters, :column => :selected_transporter_id
  end
end
