class CreateLogisticsCoreCarCarrierRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_car_carrier_rates do |t|
      t.references :route, index: { name: 'ccr_on_route_indx' }
      t.references :break_bulk_unit, index: { name: 'ccr_on_bbu_indx' }
      t.float :rate
      t.float :margin
      t.references :transporter, index: { name: 'ccr_on_transporter_indx' }
      t.references :transport_rate_period, index: { name: 'ccr_on_trp_indx' }
      t.string :rate_type
      t.references :selected_transporter, index: { name: 'ccr_on_st_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_car_carrier_rates, :logistics_core_routes, :column => :route_id
    add_foreign_key :logistics_core_car_carrier_rates, :logistics_core_lookups, :column => :break_bulk_unit_id
    add_foreign_key :logistics_core_car_carrier_rates, :logistics_core_transporters, :column => :transporter_id
    add_foreign_key :logistics_core_car_carrier_rates, :logistics_core_transport_rate_periods,
                    :column => :transport_rate_period_id
    add_foreign_key :logistics_core_car_carrier_rates, :logistics_core_transporters, :column => :selected_transporter_id,
                    :name => 'fk_ccr_on_selected_transporter'
  end
end
