class CreateLogisticsCoreOfferRequests < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_offer_requests do |t|
      t.string :request_no
      t.references :user, index: { name: 'or_on_user_indx' }
      t.references :communication_channel, index: { name: 'or_on_cc_indx' }
      t.string :status
      t.string :source_detail
      t.string :point_of_recipient
      t.date :date_of_recipient
      t.string :general_remark
      t.string :rate_level
      t.string :security_status
      t.boolean :is_sent
      t.date :sent_date
      t.string :remark
      t.date :date_status_set
      t.integer :no_of_items
      t.integer :no_of_convoy
      t.boolean :is_bulk
      t.references :client_contract, index: {name: 'or_on_client_contract_indx'}
      t.references :agent, index: { name: 'or_on_agent_indx' }
      t.references :carrier, index: { name: 'or_on_carrier_indx' }
      t.date :arrival_date
      t.float :days_before_returning_container
      t.float :days_until_loaded
      t.string :quotation_status
      t.string :additional_service_status
      t.belongs_to :operation, index: { name: 'or_on_operation_indx' }
      t.references :warehouse, index: { name: 'warehouse_on_or_indx' }, null: true

      t.timestamps
    end

    add_foreign_key :logistics_core_offer_requests, :mks_auth_users, :column => :user_id
    add_foreign_key :logistics_core_offer_requests, :logistics_core_lookups, :column => :communication_channel_id
    add_foreign_key :logistics_core_offer_requests, :logistics_core_agents, :column => :agent_id
    add_foreign_key :logistics_core_offer_requests, :logistics_core_carriers, :column => :carrier_id
    add_foreign_key :logistics_core_offer_requests, :logistics_core_operations, :column => :operation_id
    add_foreign_key :logistics_core_offer_requests, :logistics_core_warehouses, :column => :warehouse_id
  end
end
