class CreateLogisticsCoreContractBreakBulkUnitRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_contract_break_bulk_unit_rates do |t|
    	t.references :chargeable_service_unit_of_charge, index: { name: 'cabr_on_csuoc3_indx' }
      t.references :transaction_type, index: { name: 'cabr_on_tt3_indx' }
      t.references  :break_bulk_unit, index: { name: 'cabr_on_bbu3_indx' }
      t.references :client_contract, index: { name: 'cabr_on_cc3_indx' }
      t.boolean :in_contract
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_contract_break_bulk_unit_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_contract_break_bulk_unit_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_contract_break_bulk_unit_rates, :logistics_core_client_contracts,
                    :column => :client_contract_id
    add_foreign_key :logistics_core_contract_break_bulk_unit_rates, :logistics_core_lookups, :column => :break_bulk_unit_id,
    								:name => 'fk_cabr_on_bbu'
  end
end
