class CreateLogisticsCoreContractItemRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_contract_item_rates do |t|
      t.references :chargeable_service_unit_of_charge, index: { name: 'cabr_on_csuoc2_indx' }
      t.references :transaction_type, index: { name: 'cabr_on_tt2_indx' }
      t.references :client_contract, index: { name: 'cabr_on_cc2_indx' }
      t.boolean :in_contract
      t.float :margin
      t.float :minimum_quantity
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_contract_item_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_contract_item_rates, :logistics_core_lookups, :column => :transaction_type_id
    add_foreign_key :logistics_core_contract_item_rates, :logistics_core_client_contracts,
                    :column => :client_contract_id
  end
end
