class CreateLogisticsCoreFreightTonDemurrageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_freight_ton_demurrage_rates do |t|
      t.references :demurrage_rate_period, index: { name: 'ftdr_on_drp_indx' }
      t.references :transaction_type, index: { name: 'ftdr_on_tt_indx' }
      t.date :effective_date
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_freight_ton_demurrage_rates, :logistics_core_demurrage_rate_periods,
                    :column => :demurrage_rate_period_id
    add_foreign_key :logistics_core_freight_ton_demurrage_rates, :logistics_core_lookups, :column => :transaction_type_id
  end
end
