class CreateLogisticsCoreOutOfGaugeCntRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_out_of_gauge_cnt_rates do |t|
      t.references :container_size, index: { name: 'oogcr_on_cs_indx' }
      t.date :effective_date
      t.float :height_from
      t.float :height_to
      t.float :length_from
      t.float :length_to
      t.float :margin
      t.float :rate
      t.references :route, index: { name: 'oogcr_on_route_indx' }
      t.date :valid_until
      t.float :weight_from
      t.float :weight_to
      t.float :width_from
      t.float :width_to

      t.timestamps
    end

    add_foreign_key :logistics_core_out_of_gauge_cnt_rates, :logistics_core_lookups, :column => :container_size_id
    add_foreign_key :logistics_core_out_of_gauge_cnt_rates, :logistics_core_routes, :column => :route_id
  end
end
