class CreateLogisticsCoreSelfDrivingRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_self_driving_rates do |t|
      t.references :break_bulk_unit, index: { name: 'sdr_on_bbu_indx' }
      t.float :margin
      t.decimal :rate
      t.references :rate_period, index: { name: 'sdr_on_trp_indx' }
      t.string :rate_type
      t.references :route, index: { name: 'sdr_on_route_indx' }
      t.references :selected_transporter, index: { name: 'sdr_on_st_indx' }
      t.references :transporter, index: { name: 'sdr_on_transporter_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_self_driving_rates, :logistics_core_lookups, :column => :break_bulk_unit_id
    add_foreign_key :logistics_core_self_driving_rates, :logistics_core_transport_rate_periods,
                    :column => :rate_period_id
    add_foreign_key :logistics_core_self_driving_rates, :logistics_core_routes, :column => :route_id
    add_foreign_key :logistics_core_self_driving_rates, :logistics_core_transporters, :column => :transporter_id,
                    :name => 'fk_sdr_on_trans'
    add_foreign_key :logistics_core_self_driving_rates, :logistics_core_transporters, :column => :selected_transporter_id
  end
end
