class CreateLogisticsCoreTwentyFootEquivalenceUnitRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_twenty_foot_equivalence_unit_rates do |t|
      t.references :chargeable_service_unit_of_charge, index: { name: 'tfeur_on_csuoc_indx' }
      t.date :effective_date
      t.float :high
      t.float :low
      t.float :medium
      t.float :margin
      t.references :transaction_type, index: { name: 'tfeur_on_tt_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_twenty_foot_equivalence_unit_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_twenty_foot_equivalence_unit_rates, :logistics_core_lookups,
                    :column => :transaction_type_id
  end
end
