class CreateLogisticsCoreKilogramRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_kilogram_rates do |t|
      t.float :from
      t.float :to
      t.float :high
      t.float :medium
      t.float :low
      t.float :margin
      t.date :effective_date
      t.references :chargeable_service_unit_of_charge, index: { name: 'kr_on_csuoc_indx' }
      t.references :transaction_type, index: { name: 'kr_on_tt_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_kilogram_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_kilogram_rates, :logistics_core_lookups, :column => :transaction_type_id
  end
end
