class CreateLogisticsCoreItemRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_item_rates do |t|
      t.references :chargeable_service_unit_of_charge, index: { name: 'ir_on_csuoc_indx' }
      t.date :effective_date
      t.float :margin
      t.float :minimum_quantity
      t.float :rate
      t.references :transaction_type, index: { name: 'ir_on_tt_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_item_rates, :logistics_core_chargeable_service_unit_of_charges,
                    :column => :chargeable_service_unit_of_charge_id
    add_foreign_key :logistics_core_item_rates, :logistics_core_lookups, :column => :transaction_type_id
  end
end
