class CreateLogisticsCoreFreightTonStorageRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_freight_ton_storage_rates do |t|
      t.references :content_type, index: { name: 'ftsr_on_ct_indx' }
      t.references :transaction_type, index: { name: 'ftsr_on_tt_indx' }
      t.references :warehouse_rate_period, index: { name: 'ftsr_on_wrp_indx' }
      t.date :effective_date
      t.float :rate

      t.timestamps
    end

    add_foreign_key :logistics_core_freight_ton_storage_rates, :logistics_core_lookups, :column => :content_type_id
    add_foreign_key :logistics_core_freight_ton_storage_rates, :logistics_core_lookups, :column => :transaction_type_id,
                    :name => 'fk_fstr_on_tt'
    add_foreign_key :logistics_core_freight_ton_storage_rates, :logistics_core_warehouse_rate_periods,
                    :column => :warehouse_rate_period_id
  end
end
