class CreateLogisticsCoreCargoDetails < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_cargo_details do |t|
      t.integer :container_type_id, index:{name: 'cnt_type_on_cargo_detail_indx'}
      t.integer :container_size_id, index:{name: 'cnt_size_on_cargo_detail_indx'}
      t.float :quantity
      t.integer :content_type_id, index:{name: 'content_on_cargo_detail_indx'}
      t.integer :offer_request_id,index:{name: 'offer_req_on_cargo_detail_indx'}
      t.integer :cargo_type_id
      t.string :description
      t.float :weight
      t.float :length
      t.float :width
      t.float :height
      t.string :status
      t.integer :service_delivery_unit_id

      t.timestamps
    end
    add_foreign_key :logistics_core_cargo_details, :logistics_core_lookups,:column => :container_size_id
    add_foreign_key :logistics_core_cargo_details, :logistics_core_container_types,:column => :container_type_id
    add_foreign_key :logistics_core_cargo_details, :logistics_core_lookups,:column => :content_type_id
    add_foreign_key :logistics_core_cargo_details, :logistics_core_offer_requests,:column => :offer_request_id
  end
end
