class CreateLogisticsCoreBreakBulkCargoDetails < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_break_bulk_cargo_details do |t|
      t.float :actual_weight
      t.float :volume
      t.integer :quantity
      t.integer :content_type_id, index:{name: 'content_on_break_bulk_cargo'}
      t.integer :offer_request_id, index:{name: 'offer_req_on_break_bulk_cargo'}
      t.float :length
      t.float :width
      t.float :height
      t.integer :cargo_type_id, index:{name: 'cargo_type_on_break_bulk_cargo_type'}
      t.string :description
      t.integer :break_bulk_unit_id, index:{name: 'bb_unit_on_break_bulk_cargo_type'}
      t.string :status
      t.integer :service_delivery_unit_id, index:{name: 'sdu_on_break_bulk_cargo'}

      t.timestamps
    end
    add_foreign_key :logistics_core_break_bulk_cargo_details, :logistics_core_lookups,:column => :content_type_id
    add_foreign_key :logistics_core_break_bulk_cargo_details, :logistics_core_offer_requests,:column => :offer_request_id
    add_foreign_key :logistics_core_break_bulk_cargo_details, :logistics_core_lookups,:column => :cargo_type_id
    add_foreign_key :logistics_core_break_bulk_cargo_details, :logistics_core_lookups,:column => :break_bulk_unit_id
  end
end
