class CreateLogisticsCoreCustomsTransportTariffs < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_customs_transport_tariffs do |t|
      t.references :route, index: { name: 'ctt_on_route_indx' }, null: false
      t.references :entry_point, index: { name: 'ctt_on_ep_indx' }, null: false
      t.float :total_distance, null: false
      t.float :distance_to_entry_point, null: false
      t.float :proportion, null: false

      t.timestamps
    end
    add_index :logistics_core_customs_transport_tariffs, [:route_id, :entry_point_id], :unique => true, :name => 'route_entry_point_uniq_indx'
    add_foreign_key :logistics_core_customs_transport_tariffs, :logistics_core_routes, :column => :route_id
    add_foreign_key :logistics_core_customs_transport_tariffs, :logistics_core_extended_lookups, :column => :entry_point_id
  end
end
