class CreateLogisticsCoreEslTransportTariffs < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_esl_transport_tariffs do |t|
      t.references :route, index: {name: 'route_on_transport_tariffs_indx'}, null: false
      t.string :storage_point, null: false

      t.timestamps
    end
    add_index :logistics_core_esl_transport_tariffs, [:route_id, :storage_point], :unique => true, :name => 'route_storage_point_uniq_indx'
    add_foreign_key :logistics_core_esl_transport_tariffs, :logistics_core_routes, :column => :route_id
  end
end
