class CreateLogisticsCoreEslTransportTariffRates < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_esl_transport_tariff_rates do |t|
      t.references :esl_transport_tariff, index: {name: 'tariff_rate_on_transport_tariff_indx'}, null: false
      t.float :qt_from, null: false
      t.float :qt_to, null: false
      t.float :rate, null: false

      t.timestamps
    end
    add_index :logistics_core_esl_transport_tariff_rates, [:esl_transport_tariff_id, :qt_from, :qt_to], :unique => true,
              :name => 'transport_from_to_uniq_indx'
    add_foreign_key :logistics_core_esl_transport_tariff_rates, :logistics_core_esl_transport_tariffs, :column => :esl_transport_tariff_id
  end
end
