class AddReferencesToMovedObjects < ActiveRecord::Migration[5.0]
  def change
    add_index :logistics_core_operations, :declarant_id, :name => 'declarant_on_od_indx'
    add_index :logistics_core_operations, :declaration_type_id, :name => 'dty_on_od_indx'
    add_index :logistics_core_operations, :transport_mode_id, :name => 'tm_on_od_indx'
    add_index :logistics_core_operations, :customs_office_id, :name => 'co_on_od_indx'
    add_index :logistics_core_operations, :customs_office_unit_id, :name => 'cou_on_od_indx'
    add_index :logistics_core_operations, :country_of_origin_id, :name => 'coo_on_od_indx'
    add_index :logistics_core_operations, :acquisition_mode_id, :name => 'am_on_od_indx'
    add_index :logistics_core_operations, :payment_term_id, :name => 'pt_on_od_indx'
    add_index :logistics_core_operations, :delivery_term_id, :name => 'dt_on_od_indx'
    add_index :logistics_core_operations, :container_arrangement_id, :name => 'ca_on_od_indx'
    add_index :logistics_core_operations, :customs_transport_tariff_id, :name => 'ctt_on_od_indx'
    add_index :logistics_core_operations, :esl_transport_tariff_id, :name => 'ett_on_od_indx'
    add_index :logistics_core_operations, :warehouse_id, :name => 'wh_on_od_indx'

    add_foreign_key :logistics_core_operations, :logistics_core_declarants, :column => :declarant_id
    add_foreign_key :logistics_core_operations, :logistics_core_declaration_types, :column => :declaration_type_id
    add_foreign_key :logistics_core_operations, :logistics_core_extended_lookups, :column => :transport_mode_id
    add_foreign_key :logistics_core_operations, :logistics_core_customs_offices, :column => :customs_office_id
    add_foreign_key :logistics_core_operations, :logistics_core_lookups, :column => :customs_office_unit_id
    add_foreign_key :logistics_core_operations, :logistics_core_extended_lookups, :column => :acquisition_mode_id
    add_foreign_key :logistics_core_operations, :logistics_core_extended_lookups, :column => :payment_term_id
    add_foreign_key :logistics_core_operations, :logistics_core_extended_lookups, :column => :delivery_term_id
    add_foreign_key :logistics_core_operations, :logistics_core_extended_lookups, :column => :container_arrangement_id
    add_foreign_key :logistics_core_operations, :logistics_core_lookups, :column => :country_of_origin_id
    add_foreign_key :logistics_core_operations, :logistics_core_customs_transport_tariffs, :column => :customs_transport_tariff_id
    add_foreign_key :logistics_core_operations, :logistics_core_esl_transport_tariffs, :column => :esl_transport_tariff_id
    add_foreign_key :logistics_core_operations, :logistics_core_warehouses, :column => :warehouse_id
  end
end
