class CreateLogisticsCoreDocumentTypes < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_document_types do |t|
      t.string :code
      t.string :name
      t.string :description
      t.references :document_type_category, index: { name: 'dtc_on_dt' }
      t.references :document_type_origin, index: { name: 'dto_on_dt' }

      t.timestamps
    end
    add_foreign_key :logistics_core_document_types, :logistics_core_extended_lookups,
                    :column => :document_type_category_id
    add_foreign_key :logistics_core_document_types, :logistics_core_extended_lookups,
                    :column => :document_type_origin_id
  end
end
