class CreateLogisticsCoreAdditionalDocuments < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_additional_documents do |t|
      t.references :document_type, index: { name: 'ad_on_dt_indx' }
      t.references :documentable, polymorphic: true, index: {name: 'document_type_on_additional_document_indx'}
      t.integer :original
      t.integer :copy
      t.integer :certified
      t.boolean :is_endorsed
      t.boolean :is_mandatory
      t.references :transaction_type, index: { name: 'tt_on_ad_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_additional_documents, :logistics_core_document_types, :column => :document_type_id
    add_foreign_key :logistics_core_additional_documents, :logistics_core_lookups, :column => :transaction_type_id
  end
end
