class CreateLogisticsCoreAgencyPermitDocuments < ActiveRecord::Migration[5.0]
  def change
    create_table :logistics_core_agency_permit_documents do |t|
      t.references :agency, index: { name: 'apd_on_agency_indx' }
      t.references :document_type, index: { name: 'apd_on_dt_indx' }
      t.integer :original_docs
      t.integer :copy_docs
      t.integer :certified_copy_docs
      t.boolean :is_endorsed
      t.boolean :is_mandatory

      t.timestamps
    end

    add_foreign_key :logistics_core_agency_permit_documents, :logistics_core_document_types, :column => :document_type_id
    add_foreign_key :logistics_core_agency_permit_documents, :logistics_core_agencies, :column => :agency_id
  end
end
