class CreateLogisticsCoreRequiredDocuments < ActiveRecord::Migration[5.1]
  def change
    create_table :logistics_core_required_documents do |t|
      t.references :document_type, index: { name: 'rd_on_dt_indx' }
      t.integer :original
      t.integer :copy
      t.integer :certified
      t.boolean :is_endorsed
      t.boolean :is_mandatory
      t.references :agency_permit_document, index: { name: 'apd_on_rd_indx' }

      t.timestamps
    end

    add_foreign_key :logistics_core_required_documents, :logistics_core_document_types, :column => :document_type_id
    add_foreign_key :logistics_core_required_documents, :logistics_core_agency_permit_documents, column: :agency_permit_document_id
  end
end
